<script lang="ts">
  import { afterNavigate } from '$app/navigation';

  import '../../app.css';
  import logo from '$lib/assets/images/ncae_cybergames_logo.png';

  import Footer from '$lib/components/layout/Footer.svelte';
  import Navbar from '$lib/components/layout/Navbar.svelte';
  import ScrollToTop from '$lib/components/layout/ScrollToTop.svelte';
  import Lightbox from '$lib/components/ui-elements/Lightbox.svelte';
  import Spinner from '$lib/components/ui-elements/Spinner.svelte';
  import Notifications from 'svelte-notifications';

  import { isNavLink, isNavTab, type NavLink, type NavTab } from '$lib/interfaces/navigation.interface';
  import { lightboxState } from '$stores/lightboxStore';
  import { createClient } from '../../authService';
  import navTabs from '$lib/components/layout/data/nav-tabs';
  import { isAuthenticated, oidcClient } from '$stores/authStore';
  import IntercomBanner from '$lib/components/layout/IntercomBanner.svelte';
  import { Log } from 'oidc-client-ts';
  import { writable } from 'svelte/store';
  import { page } from '$app/stores';
  import HeroBanner from '$lib/components/layout/HeroBanner.svelte';
  import Env from '$lib/Env';
  import { Tooltip } from 'flowbite-svelte';
  import DismissibleElement from '$lib/components/ui-elements/DismissibleElement.svelte';

  let currentLink: NavLink | null = null;
  // we don't want handle "navigation" events on initial page load
  // because they can cause an auth loop and eventually a 414 from Keycloak
  let handleNavigation = false;
  let displayHelp = false;
  // Auth Status Store is a bit of a hack to track the status of the auth process,
  // so we are guaranteed to always provide the user with an error code they can report to support.
  const authStatusStore = writable('not initialized');

  /**
   * Create the Keycloak Client, then check if the user has permission to view the current page
   */
  async function checkAuth() {
    authStatusStore.set('[checkAuth] start');
    setTimeout(() => (displayHelp = true), 2000);
    await createClient({
      trySilentAuth: true,
      oidcLogLevel: Log.INFO,
      statusStore: authStatusStore
    });

    authStatusStore.set('[checkAuth] handleNav');
    await handleNav(window.location);
    handleNavigation = true;
    authStatusStore.set('[checkAuth] complete');
  }

  function findCurrentNavLink(nav: Array<NavTab | NavLink>, location: URL | Location): NavLink | null {
    authStatusStore.set(`find nav link ${nav} ${location}`);
    for (const n of nav) {
      if (isNavTab(n)) {
        let result = findCurrentNavLink(n.links, location);
        if (result) return result;
      }

      if (isNavLink(n)) {
        // if href is an exact match, we found our page
        if (n.href === location.pathname || n.href === location.pathname + location.hash) return n;
        // otherwise if a regex matches, we found our page
        if (n.regex && location.pathname.match(n.regex)) return n;
      }
    }

    return null;
  }

  async function handleNav(location: URL | Location) {
    authStatusStore.set('handleNav start');
    currentLink = findCurrentNavLink(navTabs, location);
    if (currentLink?.authRequired && !$isAuthenticated) {
      console.warn('not authenticated, redirecting to login');
      authStatusStore.set('redirect to login');
      await $oidcClient.login();
    }
  }

  afterNavigate((navigation) => {
    if (!handleNavigation || !navigation.to) return; // not a navigation we can handle
    handleNav(navigation.to.url);
  });

  function shouldDisplaySponsorshipBanner() {
    // display sponsorship banner from November to March
    const month = new Date().getMonth() + 1; // 0-11, so we add one
    return month >= 11 || month <= 3;
  }
</script>

<svelte:head>
  {#if Env.UmamiTrackingId}
    <!-- Umami user activity tracking -->
    <script defer src="https://cloud.umami.is/script.js" data-website-id={Env.UmamiTrackingId}></script>
  {/if}
</svelte:head>

{#if $lightboxState.isOpen}
  <Lightbox />
{/if}

{#await checkAuth()}
  <div class="flex flex-col items-center justify-center min-h-screen text-cyber-blue-900">
    <div class="block m-20">
      <img src={logo} alt="brand" class="h-28" />
    </div>
    <div class="flex flex-col items-center justify-center m-10">
      <Spinner size="20" />
      <h1 class="text-2xl font-mono font-semibold pt-5">Loading the NCAE CYBER GAMES</h1>
      {#if displayHelp}
        <h1 class="pt-5">
          This is taking longer than usual. If the page doesn't load, please reach out to
          <a href="mailto:support@c2games.org">support@c2games.org</a>
        </h1>
      {/if}
    </div>
  </div>
{:then _}
  <div class="relative min-h-screen flex flex-col text-cyber-blue-900">
    <Navbar />

    <!-- sponsorship element -->
    {#if shouldDisplaySponsorshipBanner()}
      <DismissibleElement
        slug="sponsorship-banner"
        storage="session"
        class="w-full bg-cyber-blue-900 sticky top-16 xl:top-24 z-30 border-white"
      >
        <div slot="content" class="mx-auto">
          <a data-umami-event="Sponsorship Banner" href="/sponsorship">
            <section class="text-center py-2 ">
              <h1 class="text-white text-xl xl:text-2xl uppercase">
                Actively Seeking Sponsorship
              </h1>
              <Tooltip border trigger="hover" placement="bottom">
                <p class="text-white py-2">Ask about space at our in-person invitational event!</p>
              </Tooltip>
            </section>
          </a>
        </div>
      </DismissibleElement>
    {/if}

    <IntercomBanner />
    {#if $page.data.banner}
      <HeroBanner binary={$page.data.banner.binary}>
        <h1 class="my-6" slot="title">{$page.data.banner.title}</h1>
        {#if $page.data.banner.content}
          <div>{$page.data.banner.content}</div>
        {/if}
      </HeroBanner>
    {/if}
    <main class="flex-grow h-full mx-auto w-screen {!$page.data.noContainer ? '2xl:container' : ''}">
      <!-- scroll button is 50, so we want to be above that -->
      <Notifications zIndex="60">
        <slot />
      </Notifications>
      <ScrollToTop />
    </main>
    <Footer />
  </div>
{:catch e}
  <div class="flex items-center min-h-screen text-cyber-blue-900 flex-wrap max-w-full">
    <div class="">
      <p>Uh oh! We've had a major hiccup, and it looks like the site is down.</p>
      <p>
        Please report this to us in Discord or at
        <a href="mailto:support@c2games.org">support@c2games.org</a>
      </p>
      <p>PLEASE REPORT THIS ERROR CODE: {$authStatusStore}</p>
      {#if e?.stack}
        <p class="p-1">Please Include the following information:</p>
        <pre>
          {e.stack}
        </pre>
      {/if}
    </div>
  </div>
{/await}
